; program teplomer s ASCII vystupem na seriovy port RS232C

$MOD51

var1	DATA	030H		;
var2	DATA	030H+4		;
var3	DATA	030H+8		;
var4	DATA	030H+8+4	;
var5	DATA	030H+16+4	;
var6	DATA	030H+16+8	;
var7	DATA	030H+16+8+4	;
var8	DATA	030H+32		;
var9	DATA	030H+32+4	;
var10	DATA	030H+32+8	;
var11	DATA	030H+32+8+4	;
var12	DATA	030H+32+8+8	;
prumer	DATA	120		;
	ORG 	0H		;
	JMP	tepl		;


$include(MATH.ASM)


tepl:	NOP			;
	
; mereni stridy, log 1 - pocet taktu v C/T0, log 0 - pocet taktu v C/T1
; nastaveni C/T0 a C/T1 na mod1, casovac
	MOV	TMOD, #00010001B;
	ANL	TCON, #0Fh	; vynulovat preteceni a stopnout je
	MOV	TL0, #0		;
	MOV	TH0, #0		; nulovani C/T0
	MOV	TL1, #0		;
	MOV	TH1, #0		; nulovani C/T1
; nalezeni synchronu
	MOV	R2, #64		; 64 mereni
	JB	T0, $		;
	JNB	T0, $		;
; vlastni merici smycka
loopme: setb	TR0		;
	jb	T0, $		;
	clr	TR0		; signal v "1"
	setb	TR1		;
	jnb	T0, $		;
	clr	TR1		; signal v "0"
	DJNZ	R2, loopme	;		

; ulozeni "1" stavu do var1
	MOV	A, TL0		;
	ADD	A, #189		; korekce  za (5-2) instrukce*64-3
	MOV	var1, A		;
	MOV	A, TH0		;
	ADDC	A, #0		; pricteni preteceni radu od TL0
	MOV	var1+1, A	;
; ulozeni "0" stavu do var2
	MOV	A, TL1		;
	ADD	A, #64		; korekce  za (3-2) instrukci*64
	MOV	var2, A		;
	MOV	A, TH1		;
	ADDC	A, #0		; pricteni preteceni radu od TL1
	MOV	var2+1, A	;

; konstanty do var3 a var4
	MOV	var3, #0A6h	;
	MOV	var3+1, #05h	; 1446 = 05A6h
	MOV	var4, #0A9h	;
	MOV	var4+1, #02h	;  681 = 02A9h

; vypocet teploty
	SOUCIN	var1, var3, var5, var6	; vysledek do var5
	SOUCIN	var2, var4, var7, var8	; vysledek do var7
	
	PLUS	var1, var2	; jmenovatel do var1

; zjisteni znamenka
	mov	R0, #var5	;
	mov	R1, #var7	;
	call	cmp		;
	JC	kladne		;
;
	MINUS 	var7, var5	; zaporny citatel do var7
	mov	A, var7		; premisteni do var5
	mov	var5, A		;
	mov	A, var7+1	;
	mov	var5+1,A	;
	mov	A, var7+2	;
	mov	var5+2, A	;
	mov	A, var7+3	;
	mov	var5+3, A	;
	mov	R7, #255	; znamenko -
	JMP	hps		;
;	
kladne:	MINUS	var5, var7	; kladny citatel do var5
	mov	R7, #0		; znamenko +
	
hps:	PODIL	var5, var1, var9, var10	; var9 vysledek
;
; prumer z 256 hodnot
	
	PLUS	prumer, var9	;	
	
	INC	R6		;	
	mov	A, R6		;
	JZ	nenuly		;	
	jmp	nuly		;
nenuly:	NOP			;
	
; prevod do BCD
	BINBCD 	prumer+1, var11	;
; nulovani prumer
	mov	prumer, #0	;
	mov	prumer+1, #0	;
	mov	prumer+2, #0	;
	mov	prumer+3, #0	;
	mov	prumer+4, #0	;

; castecny opis na P1
	MOV	A, var11	;
	MOV	P1, A		;
	
; nastaveni serioveho portu na 9600b/s
	ANL	TMOD, #0Fh	;
	ORL	TMOD, #00100000B;
	MOV	TH1, #0FDh	;
	ANL	PCON, #7Fh	;
	MOV	SCON, #01000000B;
	SETB	TR1		;
	CLR	RI		;
	CLR	TI		;

; znamenko
	MOV	A, R7		;
	JZ	kld
	mov	A, #45
	jmp	nkld		;
kld:	mov	A, #32
nkld:	MOV	SBUF, A		;
	JNB	TI, $		;
	CLR	TI		;
; stovky 	
	MOV	A, var11+1	; 
	ANL	A, #0F0h	;
	SWAP	A		;
	ADD	A, #48		;
	MOV	SBUF, A		;
	JNB	TI, $		;
	CLR	TI		;
; desitky
	MOV	A, var11+1	; 
	ANL	A, #0Fh		;
	ADD	A, #48		;
	MOV	SBUF, A		;
	JNB	TI, $		;
	CLR	TI		;
;jednotky
	MOV	A, var11		; 
	ANL	A, #0F0h	;
	SWAP	A		;
	ADD	A, #48		;
	MOV	SBUF, A		;
	JNB	TI, $		;
	CLR	TI		;
; desetinna tecka
	MOV	A, #46		;
	MOV	SBUF, A		;
	JNB	TI, $		;
	CLR	TI		;
; desetiny
	MOV	A, var11	; 
	ANL	A, #0Fh		;
	ADD	A, #48		;
	MOV	SBUF, A		;
	JNB	TI, $		;
	CLR	TI		;
; Enter
	MOV	A, #13		; 
	MOV	SBUF, A		;
	JNB	TI, $		;
	CLR	TI		;


;nulovani pameti
nuly:	MOV	R0, #30h	;
	MOV	R2, #60		;
nuluj:	MOV	@R0, #0		;
	INC	R0		;
	DJNZ	R2, nuluj	;
	
	JMP	0		;	

ssss:	JMP	ssss
	END			;

